// Tea -    ,    
//        .

// (c) Proteus
// icq: 133575351  email:lawnmower-man@mail.ru 

#include<stdio.h>
#include<memory.h>

typedef unsigned char byte;
typedef unsigned long dword;


#define TEA_CONST 0x9E3779B9 // (sqrt(5)-1) * (2^31)
#define TEA_ROUNDS 32

class TEA{
	inline void _Encrypt(dword &l,dword &r,dword key[4]);
	inline void _Decrypt(dword &l,dword &r,dword key[4]);
public:
	void EncryptBlock(byte in[8],byte out[8],byte key[16]);
	void DecryptBlock(byte in[8],byte out[8],byte key[16]);
};

void TEA::_Encrypt(dword &l,dword &r,dword key[4])
{
	dword sum=0;
	for(unsigned int n=0; n<TEA_ROUNDS; n++) {
		sum+=TEA_CONST;
		l+=((r<<4)+key[0])^(r+sum)^((r<<5)+key[1]);
		r+=((l<<4)+key[2])^(l+sum)^((l<<5)+key[3]);
	}
}

void TEA::_Decrypt(dword &l,dword &r,dword key[4])
{
	dword sum=TEA_CONST*TEA_ROUNDS;
	for(unsigned int n=0; n<TEA_ROUNDS; n++) {
		r-=((l<<4)+key[2])^(l+sum)^((l<<5)+key[3]);
		l-=((r<<4)+key[0])^(r+sum)^((r<<5)+key[1]);
		sum-=TEA_CONST;
	}
}

void TEA::EncryptBlock(byte in[8],byte out[8],byte key[16])
{
	dword l,r;
	dword *_in =(dword*) in;
	dword *_out=(dword*)out;
	l=_in[0]; r=_in[1];
	_Encrypt(l,r,(dword*)key);
	_out[0]=l; _out[1]=r;
}


void TEA::DecryptBlock(byte in[8],byte out[8],byte key[16])
{
	dword l,r;
	dword *_in =(dword*) in;
	dword *_out=(dword*)out;
	l=_in[0]; r=_in[1];
	_Decrypt(l,r,(dword*)key);
	_out[0]=l; _out[1]=r;
}


void main()
{
	byte res1[8],res2[8];
	byte data[]="12345678";
	byte key[]={"qwerty01" "qwerty02"};
	byte test[8]={0x88,0x6d,0x4e,0x88,0xd4,0x66,0x0e,0x86};

	TEA tea;
	tea.EncryptBlock(data,res1,key);
	tea.DecryptBlock(res1,res2,key);

	if(sizeof(dword)!=4 || sizeof(byte)!=1) printf("type error\n\a"),getchar();
	if(memcmp(res1,test,8) || memcmp(res2,data,8)) printf("Internal error!\n\a"),getchar();
	printf("done...\n");
}